#include<stdio.h>
#include<stdlib.h>
#include<inttypes.h>
#include"fp-struct.h"

uint64_t N = 1000000;





void TwoSum32 (float a, float b, float* s, float* r)  {
	float aa,bb,da,db;
	*s = a+b;
	aa = *s-b;    bb = *s-a;
	da = a-aa;   db = b-bb;
	*r = da+db;
}

/* assumes exponent(a) >= exponent(b) */
void FastTwoSum32 (float a, float b, float* s, float* r)  {
	float bb;
	*s = a+b;
	bb = *s-a;
	*r = b-bb;
}





void	sums(float *a)
{    
	uint64_t i;
	float s,e,ss,se;
	double d;
	binary32 z, ref;

	printf("N=%1.e\n", (double)N);

 	d=0;
	for(i=0; i<N; i++)
		d += a[i];
	printf("decreasing values, double:  d=%1.20e\n", d);

 	d=0;
	for(i=0; i<N; i++)
				d += a[N-1-i];
	
	printf("increasing values, double:  d=%1.20e\n", d);
	ref.f=d; /* rounding there */

 	s=0;
	for(i=0; i<N; i++)
		s += a[i];
	z.f = s;
	printf("decreasing values, float:  s=%1.10e\n  diff in ulps with double %i\n", s, z.i32-ref.i32);

 	s=0;
	for(i=0; i<N; i++)
		s += a[N-1-i];
	z.f = s;
	printf("increasing values, float:  s=%1.10e\n  diff in ulps with double %i\n", s, z.i32-ref.i32);

 	s=0;
	se=0;
	for(i=0; i<N; i++){
		TwoSum32 (s, a[i], &ss, &e);
		se+=e;
		s=ss;
	}
	s=s+se;
	z.f = s;
	printf("decreasing values, TwoSum:  s=%1.10e\n  diff in ulps with double %i\n", s, z.i32-ref.i32);


 	s=0;
	se=0;
	for(i=0; i<N; i++){
		TwoSum32 (s, a[N-1-i], &ss, &e);
		se+=e;
		s=ss;
	}
	s=s+se;
	z.f = s;
	printf("increasing values, TwoSum:  s=%1.10e\n  diff in ulps with double %i\n", s, z.i32-ref.i32);

 	
	s=0;
	se=0;
	for(i=0; i<N; i++){
		FastTwoSum32 (s, a[i], &ss, &e);
		se+=e;
		s=ss;
	}
	s=s+se;
	z.f = s;
	printf("increasing values, FastTwoSum:  s=%1.10e\n  diff in ulps with double %i\n", s, z.i32-ref.i32);

}





int	main(int argc, char *argv[])
{    
	float *a;
	uint64_t i;

	a=calloc(sizeof(float), N);

	printf("Sums on the array of inverses\n");
	for(i=0; i<N; i++)
		a[i] = 1.0/(i+1);
	sums(a);


	return 0;

}

